<?php

/**
 * inf_planifica_fp actions.
 *
 * @package    cobro_coactivo
 * @subpackage inf_planifica_fp
 * @author     ManuelEnriqueParedesLopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_planifica_fpActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_PLANIFICA_FP_V',
        'CBR_FACILIDAD_PAGO_V',
        'CBR_PROCESO_COACTIVO',
        'CBR_AVOCA_CONOC',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V',
        'CBR_TIPO_DOCUMENTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_facilidad_pago' => 'CBR_PLANIFICA_FP_V'
        ),
        'CBR_PROCESO_COACTIVO,LEFT' =>
        array(
            'id_proceso_coactivo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_AVOCA_CONOC,LEFT' =>
        array(
            'id_avoca_conoc' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT'=>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_documento' => 'CBR_AVOCA_CONOC'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_PLANIFICA_FP_V' =>
        array(
            'id_planifica_fp' => 'id_planifica_fp',
            'id_facilidad_pago' => 'id_facilidad_pago',
            'fecha_inicio' => 'fecha_inicio',
            'valor_total' => 'valor_total',
            'numero_cuotas' => 'numero_cuotas',
            'id_tasa_interes_corriente' => 'id_tasa_interes_corriente',
            'id_tasa_interes_mora' => 'id_tasa_interes_mora',
            'descripcion' => 'descripcion',
            'interes_mora' => 'interes_mora',
            'interes_corriente' => 'interes_corriente',
            'valor_interes_mora' => 'valor_interes_mora',
            'valor_interes_corriente' => 'valor_interes_corriente'
        ),
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'id_proceso_coactivo' => 'id_proceso_coactivo',
            'id_avoca_conoc' => 'id_avoca_conoc',
            'fecha_registro' => 'fecha_registro'
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'no_proceso' => 'no_proceso',
            'fecha' => 'fecha_coactivo'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo',
            'anho_remision' => 'id_anhos'
        ),
        'CBR_AVOCA_CONOC' =>
        array(
            'no_auto' => 'no_auto',
            'fecha' => 'fecha_avoca',
            'id_tipo_documento' => 'id_tipo_documento'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        ),
        'CBR_TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'descripcion_tipdoc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'fecha_inicio', 'id_anhos', 'cod_titulo'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_PLANIFICA_FP_V' =>
        array(
            'id_planifica_fp,a' => array('!=' => array(-1)),
            'id_planifica_fp,b' => array('=' => array('id_planifica_fp')),
            'fecha_inicio' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_facilidad_pago' => array('=' => array('id_facilidad_pago')),
            'id_tasa_interes_corriente' => array('=' => array('id_tasa_interes_corriente')),
            'id_tasa_interes_mora' => array('=' => array('id_tasa_interes_mora')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'no_proceso' => array('=' => array('no_resolucion'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo')),
            'anho_remision' => array('=' => array('id_anhos'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_planifica_fp'; //identificador de la tabla
    protected $id_names = array('id_planifica_fp'); //llave primaria
    protected $field_names = array('id_facilidad_pago', 'fecha_inicio', 'valor_total', 'numero_cuotas',
        'id_tasa_interes_corriente', 'id_tasa_interes_mora', 'descripcion'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_PLANIFICA_FP'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_planifica_fp'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

          
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
